<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 34.40</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container">
    <div class="text-center mt-3 mb-3">
      <h2>F100 - Quản trị người dùng</h2>
    </div>
    <div class="jumbotron container">        
        <div class="row form-group">
          <label class="col-sm-2 col-form-label" for="firstNameInput">First name</label>
          <div class="col-sm-3">
              <input type="text" id="firstNameInput" class="form-control" placeholder="Nhap first name ...">
          </div>
          <label class="col-sm-2 col-form-label" for="lastNameInput">Last name</label>
          <div class="col-sm-3">
              <input type="text" id="lastNameInput" class="form-control" placeholder="Nhap last name ...">
          </div>
          <div class="col-sm-2">
            <button class="btn btn-success" id="btn-filter">Filter user</button>
          </div>
        </div>
    </div>
  </div>

  <div class="container mt-2">
    <div class="row">
      <div class="col-12 text-nowrap">
        <table id="table-users" class="table table-bordered table-striped table-hover">
          <thead>
            <tr>
              <th>Mã người dùng</th>
              <th>Firstname</th>
              <th>Lastname</th>
              <th>Country</th>
              <th>Subject</th>
              <th>Customer Type</th>
              <th>Register Status</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>
            
          </tbody>
        </table>
      </div>
    </div>
  </div>
</body>
​
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gUsersArr = [];

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $("#btn-filter").on("click", onBtnFilterUserClick);
  //hàm gán event hadler (sự kiện) click và hàm thực thi, khi ấn nút chi tiết
  $("#table-users").on("click", ".btn-detail", function(){
    onBtnDetailClick(this);
  });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  /**
   * Call API để get all users và lưu vào mảng toàn cục gUsersArr.
   * gUsersArr được sử dụng cho mục đích filter về sau
  */
  // Hàm thực thi khi load trang
  function onPageLoading() {
    // gọi api load dữ liệu users
    $.ajax({
      url: 'http://203.171.20.210:8080/devcamp-register-java-api/users',
      type: 'GET',
      dataType: 'json',
      async: false,
      success: function (paramObjectUser) {
        gUsersArr = paramObjectUser;
        console.log(gUsersArr);
      }
    });
    //hàm gọi load dữ liệu vào table
    fillDataTableUser(gUsersArr);
  }
  //hàm xử lý sự kiện nút filter user được ấn
  function onBtnFilterUserClick(paramUser){
    console.log("nút filterUser được ấn");
    //b1 khai báo biến lưu dữ liệu đối tượng, thu thập dữ liệu
    var vFilterObj = {
      firstName: "",
      lastName: "",
    }
    getDataToForm(vFilterObj);
    //b2 kiểm tra 
    //b3 thục hiện tièm kiếm và sử lý dữ liệu
    var vArrFilterUser = findUserByFilter(vFilterObj);
    var vTable = $("#table-users") // truy xuất table qua id
    vTable.find("tr:gt(0)").html("");
    if(vArrFilterUser.length > 0){
      //hiện thông báo đã được tìm thấy
      alert("tìm thây " + vArrFilterUser.length + " kết quả phù hợp");
      //hiển thị danh sách tìm được ra table
      findDataTableUser(vArrFilterUser)
    }
    else{
      alert("Không tìm thấy kết quả phù hợp");
      return false;
    }
  }
  //hàm xử lý sự kiện click detail
  function onBtnDetailClick(paramDetail){
    "use strict";
    var vCurenRow = $(paramDetail).closest("tr");
    var vUserId = $(vCurenRow).find("td:eq(0)").text();
    console.log("Mã người dùng (id): " + vUserId);
    alert("Mã người dùng (id): " + vUserId);
  };
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/    
  //hàm thu thập dữ liệu
  function getDataToForm(paramKeyword){
    paramKeyword.firstName = $("#firstNameInput").val().trim();
    paramKeyword.lastName = $("#lastNameInput").val().trim();
  }
  //hàm sử lý việc tìm kiếm user
  // -input/start
  //- paramKeyWordObj (là một obj chưa các đối tượng thu thập từ form: firstname, lastname)
  // - output/end: trả về một mảng (array) gồm các đối tượng obj (user)
  function findUserByFilter(paramKeyWordObj){
    "use strict";
    const bArrResultObj = [];
    //kiểm tra firstname, lastname điều được nhập
    if(paramKeyWordObj.firstName != "" && paramKeyWordObj.lastName != ""){
      for(let bI = 0; bI < gUsersArr.length; bI++){
        const bItemUserObj = gUsersArr[bI];
        //thục hiện so sách từ khóa nhập vào với dữ liệu user
        if(paramKeyWordObj.firstName.toLowerCase() === bItemUserObj.firstname.toLowerCase() && 
        paramKeyWordObj.lastName.toLowerCase() === bItemUserObj.lastname.toLowerCase()){
              bArrResultObj.push(bItemUserObj); 
        }
      }
    }
    //kiểm tra firstname lastname được nhập
    if(paramKeyWordObj.firstName != "" || paramKeyWordObj.lastName != ""){
      for(var bI = 0; bI < gUsersArr.length; bI++){
        const bItemUserObj = gUsersArr[bI];
        //thục hiện so sách từ khóa nhập vào với dữ liệu user
        if(paramKeyWordObj.firstName.toLowerCase() === bItemUserObj.firstname.toLowerCase() &&
        paramKeyWordObj.lastName.toLowerCase() === bItemUserObj.lastname.toLowerCase()){
              bArrResultObj.push(bItemUserObj);
        }
      }
    }
    return bArrResultObj;
  }
  //hàm hiển thị danh sách được tìm ra
  function findDataTableUser(paramObjUser){
    var vUserTable = $("#table-users");
    for(let bI = 0; bI < paramObjUser.length; bI++){
      var bNewRow = $("<tr/>").appendTo(vUserTable)

      $("<td/>", {
        html: paramObjUser[bI].id
      }).appendTo(bNewRow);

      $("<td/>", {
        html: paramObjUser[bI].firstname
      }).appendTo(bNewRow);

      $("<td/>", {
        html: paramObjUser[bI].lastname
      }).appendTo(bNewRow);

      $("<td/>", {
        html: paramObjUser[bI].country
      }).appendTo(bNewRow);

      $("<td/>", {
        html: paramObjUser[bI].subject
      }).appendTo(bNewRow);

      $("<td/>", {
        html: paramObjUser[bI].customerType
      }).appendTo(bNewRow);

      $("<td/>", {
        html: paramObjUser[bI].registerStatus
      }).appendTo(bNewRow);

      //ở action
      var vAction = $("<td/>").appendTo(bNewRow);
      $('<button/>', {
        html: "Chi tiết",
      }).addClass("btn btn-primary btn-detail")
      .appendTo(vAction);

    } 
  }
  /**
   * Hàm load data vào table
   * Input: mảng users
   * Output: table có dữ liệu
   */ 
  function fillDataTableUser(paramObjectUser) {
    var vUserTable = $('#table-users');
    for (var bI = 0; bI < paramObjectUser.length; bI++) {
      var bNewRow = $('<tr/>').appendTo(vUserTable);
      var bId = $('<td/>', {
        html: paramObjectUser[bI].id
      }).appendTo(bNewRow);

      var vFirstName = $('<td/>', {
        html: paramObjectUser[bI].firstname
      }).appendTo(bNewRow);

      var vLastName = $('<td/>', {
        html: paramObjectUser[bI].lastname
      }).appendTo(bNewRow);

      var vCountry = $('<td/>', {
        html: paramObjectUser[bI].country
      }).appendTo(bNewRow);

      var vSubject = $('<td/>', {
        html: paramObjectUser[bI].subject
      }).appendTo(bNewRow);

      var vCustomerType = $('<td/>', {
        html: paramObjectUser[bI].customerType
      }).appendTo(bNewRow);

      var vRegisterStatus = $('<td/>', {
        html: paramObjectUser[bI].registerStatus
      }).appendTo(bNewRow);

      var vAction = $('<td/>').appendTo(bNewRow);
      var vDetailButon = $("<button/>", {
        text: "Chi tiết",
      }).addClass("btn btn-primary")
        .appendTo(vAction);
    }
  }

</script>

</html>
​